<?php
/** simple options */
class myoptions {
	function getOptions() {
		$options = get_option('simple_options');
		if (!is_array($options)) {
			$options['banner'] = false;
			$options['topbar'] = true;
			$options['bottombar'] = true;
			$options['banner_alt'] = '';
			update_option('simple_options', $options);
		}
		return $options;
	}

	function add() {
		if(isset($_POST['simple_save'])) {
			$options = myoptions::getOptions();
			if ($_POST['topbar']) {
				$options['topbar'] = (bool)true;
			} else {
				$options['topbar'] = (bool)false;
			}
			if ($_POST['bottombar']) {
				$options['bottombar'] = (bool)true;
			} else {
				$options['bottombar'] = (bool)false;
			}

			if ($_POST['notice']) {
				$options['notice'] = (bool)true;
			} else {
				$options['notice'] = (bool)false;
			}
			if ($_POST['target']) {
				$options['target'] = (bool)true;
			} else {
				$options['target'] = (bool)false;
			}
			$options['banner'] = $_POST['banner'];
			$options['banner_link'] = $_POST['banner_link'];
			$options['banner_alt'] = stripslashes($_POST['banner_alt']);
			update_option('simple_options', $options);

		} else {
			myoptions::getOptions();
		}

		add_theme_page('Theme Options','Theme Options', 'edit_themes', basename(__FILE__), array('myoptions', 'display'));
	}

	function display() {
		$options = myoptions::getOptions();
?>

<form action="#" method="post" enctype="multipart/form-data" name="simple_form" id="simple_form">
  <div class="wrap">
    <h2> Custom Sidebar </h2>
    <table class="form-table">
      <tbody>
        <tr valign="top">
          <td width="50%" scope="row"> Check this if you need top_sidebar<br />
            ( on the top of sidebar with a width of 300px )<br />
			<b>Note:</b> widgets in the top_sidebar will not shown if you uncheck this
</td>
          <td><label>
            <input name="topbar" type="checkbox" value="checkbox" <?php if($options['topbar']) echo "checked='checked'"; ?> />
            </label>
          </td>
        </tr>
        <tr valign="top">
          <td scope="row"> Check this if you want to show sidebar in two colums<br />
            ( on the bottom of sidebar show in default ) <br />
<b>Note:</b>widgets in the leftsidebar and rightsidebar will not show if you uncheck this</td>
          <td><label>
            <input name="bottombar" type="checkbox" value="checkbox" <?php if($options['bottombar']) echo "checked='checked'"; ?> />
            </label>
          </td>
        </tr>
      </tbody>
    </table>
    <br />
    <hr />
    <h2> Custom Banner</h2>
    <p>Please make sure your banner not too large</p>
    <table class="form-table">
      <tbody>
        <tr valign="top">
          <td scope="row"> Check this for using customed banner</td>
          <td><label>
            <input name="notice" type="checkbox" value="checkbox" <?php if($options['notice']) echo "checked='checked'"; ?> />
            </label>
          </td>
        </tr>
        <tr valign="top">
          <td scope="row"> Image URL </td>
          <td><label>
            <input name="banner" type="text" value="<?php echo($options['banner']); ?>" size="80" />
            With http:// </label>
          </td>
        </tr>
        <tr valign="top">
          <td scope="row"> Ad link </td>
          <td><label>
            <input name="banner_link" type="text" value="<?php echo($options['banner_link']); ?>" size="80" />
            With http:// </label>
          </td>
        </tr>
        <tr valign="top">
          <td scope="row"> Check this if you want<br />
            to open link in a new window</td>
          <td><label>
            <input name="target" type="checkbox" value="checkbox" <?php if($options['target']) echo "checked='checked'"; ?> />
            </label>
          </td>
        </tr>
        <tr>
          <td>Image Title</td>
          <td><label>
            <textarea name="banner_alt" id="banner_alt" cols="50" rows="8" style="width:100%" class="code"><?php echo($options['banner_alt']); ?></textarea>
            </label>
          </td>
        </tr>
      </tbody>
    </table>
    <p class="submit">
      <input class="button-primary" type="submit" name="simple_save" value="Update" />
    </p>
  </div>
</form>
<?php
	}
}
// register functions
add_action('admin_menu', array('myoptions', 'add'));
?>
<?php
/*sidebar*/
if( function_exists('register_sidebar') ) {
	register_sidebar(array(
		'name' => 'top_sidebar',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h2>',
		'after_title' => '</h2>'
	));
	register_sidebar(array(
		'name' => 'leftsidebar',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h2>',
		'after_title' => '</h2>'
	));
	register_sidebar(array(
		'name' => 'rightsidebar',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h2>',
		'after_title' => '</h2>'
	));
}
//recent comments
function dp_recent_comments($no_comments = 5, $comment_len = 65) { 
    global $wpdb; 
    $request = "SELECT * FROM $wpdb->comments"; 
    $request .= " JOIN $wpdb->posts ON ID = comment_post_ID"; 
    $request .= " WHERE comment_approved = '1' AND post_status = 'publish' AND post_password =''"; 
    $request .= " ORDER BY comment_date DESC LIMIT $no_comments"; 
    $comments = $wpdb->get_results($request); 
    if ($comments) { 
        foreach ($comments as $comment) { 
            ob_start(); 
            ?>
<li> <a href="<?php echo get_permalink( $comment->comment_post_ID ) . '#comment-' . $comment->comment_ID; ?>"><?php echo dp_get_author($comment); ?>: </a><?php echo strip_tags(substr(apply_filters('get_comment_text', $comment->comment_content), 0, $comment_len)); ?></li>
<?php 
            ob_end_flush(); 
        } 
    } else { 
        echo '<li>No comment</li>'; 
    } 
}

function dp_get_author($comment) { 
    $author = ""; 
    if ( empty($comment->comment_author) ) 
        $author = 'Anonymous'; 
    else 
        $author = $comment->comment_author; 
    return $author; 
}


/* popular post*/
function most_popular_posts($no_posts = 10,  $before = '<li>', $after = '</li>', $show_pass_post = false, $duration='60') {
//定制参数，可以自己修改相关参数，以便写样式
global $wpdb;
$request = "SELECT ID, post_title, COUNT($wpdb->comments.comment_post_ID) AS 'comment_count' FROM $wpdb->posts, $wpdb->comments";
//在数据库里选择所需的数据
$request .= " WHERE comment_approved = '1' AND $wpdb->posts.ID=$wpdb->comments.comment_post_ID AND post_status = 'publish'";
//筛选数据，只统计公开的文章
if(!$show_pass_post) $request .= " AND post_password =''";
if($duration !="") { $request .= " AND DATE_SUB(CURDATE(),INTERVAL ".$duration." DAY) < post_date ";
}
$request .= " GROUP BY $wpdb->comments.comment_post_ID ORDER BY comment_count DESC LIMIT $no_posts";
//按评论数排序
$posts = $wpdb->get_results($request);
$output = '';
if ($posts) {
foreach ($posts as $post) {
$post_title = stripslashes($post->post_title);
$comment_count = $post->comment_count;
$permalink = get_permalink($post->ID);
$output .= $before . '<a href="' . $permalink . '" title="' . $post_title.'">' . $post_title . '</a> (' . $comment_count.' Comments)' . $after;
}
//输出文章列表项
} else {
$output .= $before . "None found" . $after;
//没有文章时则输出
}
echo $output;
}

/** Comments */
if (function_exists('wp_list_comments')) {
	// comment count
	add_filter('get_comments_number', 'comment_count', 0);
	function comment_count( $commentcount ) {
		global $id;
		$_commnets = get_comments('post_id=' . $id);
		$comments_by_type = &separate_comments($_commnets);
		return count($comments_by_type['comment']);
	}
}

// custom comments
function custom_comments($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment;
	global $commentcount;
	if(!$commentcount) {
		$commentcount = 0;
	}
?>
<li class="comment<?php if($comment->comment_author_email == get_the_author_email()) echo ' admin'; ?>" id="comment-<?php comment_ID() ?>">
  <div style="clear:both"></div>
  <?php if (get_option('show_avatars')) { ?>
  <div class="info"> <span class="rightmargin">
    <?php if (get_comment_author_url()) : ?>
    <a id="commentauthor-<?php comment_ID() ?>" href="<?php comment_author_url() ?>" rel="external nofollow" target="_blank"><?php comment_author(); ?></a>
    <?php else : ?>
    <span id="commentauthor-<?php comment_ID() ?>"><?php comment_author(); ?></span>
    <?php endif; ?>
    <?php comment_date('Y.n.j') ?>
    at
    <?php comment_time('H:i') ?>
    <?php
			if (function_exists("qc_comment_edit_link")) {
				qc_comment_edit_link('', ' | ', '', __('Edit'));
			}
			edit_comment_link(__('Edit'), '(', ')');
		?>
    </span>
    <?php if(!function_exists('mailtocommenter_button')) {comment_reply_link(array_merge( $args, array('reply_text' => 'Reply', 'depth' => $depth, 'max_depth' => $args['max_depth'])));	} else if(function_exists('mailtocommenter_button')&& $depth<get_option('thread_comments_depth')) { ?>
    <a  rel='nofollow' class='comment-reply-link' href="javascript:void(0);" onclick="addComment.moveForm('comment-<?php comment_ID() ?>','<?php comment_ID() ?>', 'respond', '<?php echo $post->ID; ?>');RE_CON.reply('commentauthor-<?php comment_ID() ?>','comment-<?php comment_ID() ?>','comment'); ">
    <?php _e('Reply'); ?>
    </a>
    <?php } else { ?>
    <a  rel='nofollow' class='comment-reply-link' href="javascript:void(0);" onclick="RE_CON.reply('commentauthor-<?php comment_ID() ?>','comment-<?php comment_ID() ?>','comment'); ">
    <?php _e('Reply'); ?>
    </a>
    <?php }?>
    | <a href="javascript:void(0);" onClick="RE_CON.quote('commentauthor-<?php comment_ID() ?>', 'comment-<?php comment_ID() ?>', 'body-<?php comment_ID() ?>', 'comment');">
    <?php _e('Quote'); ?>
    </a> </div>
  <?php echo get_avatar($comment, 40);  ?>
  <?php if ($comment->comment_approved == '0') : ?>
  <div class="content"><em>
    <?php _e('Your comment is awaiting moderation.') ?>
    </em> </div>
  <?php endif; ?>
  <div class="content"  id="body-<?php comment_ID() ?>">
    <?php comment_text(); ?>
  </div>
  <?php } else { ?>
  <div class="sinfo"> <span class="rightmargin">
    <?php if (get_comment_author_url()) : ?>
    <a id="commentauthor-<?php comment_ID() ?>" href="<?php comment_author_url() ?>" rel="external nofollow" target="_blank">
    <?php comment_author(); ?>
    </a>
    <?php else : ?>
    <span id="commentauthor-<?php comment_ID() ?>">
    <?php comment_author(); ?>
    </span>
    <?php endif; ?>
    <?php comment_date('Y.n.j') ?>
    at
    <?php comment_time('H:i') ?>
    <?php
			if (function_exists("qc_comment_edit_link")) {
				qc_comment_edit_link('', ' | ', '', __('Edit'));
			}
			edit_comment_link(__('Edit'), '(', ')');
		?>
    </span>
    <?php if(!function_exists('mailtocommenter_button')) {comment_reply_link(array_merge( $args, array('reply_text' => 'Reply', 'depth' => $depth, 'max_depth' => $args['max_depth'])));	} else if(function_exists('mailtocommenter_button')&& $depth<get_option('thread_comments_depth')) { ?>
    <a  rel='nofollow' class='comment-reply-link' href="javascript:void(0);" onclick="addComment.moveForm('comment-<?php comment_ID() ?>','<?php comment_ID() ?>', 'respond', '<?php echo $post->ID; ?>');RE_CON.reply('commentauthor-<?php comment_ID() ?>','comment-<?php comment_ID() ?>','comment'); ">
    <?php _e('Reply'); ?>
    </a>
    <?php } else { ?>
    <a  rel='nofollow' class='comment-reply-link' href="javascript:void(0);" onclick="RE_CON.reply('commentauthor-<?php comment_ID() ?>','comment-<?php comment_ID() ?>','comment'); ">
    <?php _e('Reply'); ?>
    </a>
    <?php }?>
    | <a href="javascript:void(0);" onClick="RE_CON.quote('commentauthor-<?php comment_ID() ?>', 'comment-<?php comment_ID() ?>', 'body-<?php comment_ID() ?>', 'comment');">
    <?php _e('Quote'); ?>
    </a> </div>
  <?php if ($comment->comment_approved == '0') : ?>
  <div class="scontent"><em>
    <?php _e('Your comment is awaiting moderation.') ?>
    </em> </div>
  <?php endif; ?>
  <div class="scontent"  id="body-<?php comment_ID() ?>">
    <?php comment_text(); ?>
  </div>
  <?php } ?>
  <?php
}
?>
